Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-1.6-compat
%global eclipse_base %{_libdir}/eclipse
%global install_loc %{_datadir}/eclipse/dropins/checkstyle
%global cs_ver 4.4
%global eclipse_ver 3.5

Summary:   Checkstyle plugin for Eclipse
Name:      eclipse-checkstyle
Version:   4.0.1
Release:   alt2_14jpp6
License:   LGPLv2+
Group:     Development/Java
URL:       http://eclipse-cs.sourceforge.net
BuildArch: noarch

Source0: CheckstylePlugin-v4_0_1.tar.bz2
Source10: checkout_and_build_tarball.sh

# remove problematic getEclipseClasspath call and checkstyle jar inclusion
Patch0: %{name}-%{version}.patch
# remove problematic eclipse 3.0 backwards compatibility
Patch1: %{name}-%{version}-tabwidth.patch

Requires: eclipse-platform >= 1:%{eclipse_ver}
Requires: eclipse-cvs-client
Requires: eclipse-jdt
Requires: checkstyle4 = 0:%{cs_ver}
Requires: checkstyle4-optional = 0:%{cs_ver}

BuildRequires: jpackage-utils >= 0:1.5
BuildRequires: ant >= 0:1.6
BuildRequires: eclipse-pde >= 1:%{eclipse_ver}
BuildRequires: eclipse-cvs-client
BuildRequires: checkstyle4 = 0:%{cs_ver}
BuildRequires: checkstyle4-optional = 0:%{cs_ver}

%description
The Eclipse Checkstyle plugin integrates the Checkstyle Java code
auditor into the Eclipse IDE. The plugin provides real-time feedback
to the user about violations of rules that check for coding style and
possible error prone code constructs. 

%prep
%setup -q -c
%patch0
%patch1

# rewrite classpath
perl -p -i -e "s/checkstyle-all-%{cs_ver}.jar/[checkstyle-%{cs_ver}].jar,\
[checkstyle-optional-%{cs_ver}].jar,[commons-beanutils-core].jar,\
[commons-logging].jar,[antlr].jar/g" CheckstylePlugin/META-INF/MANIFEST.MF

%build
# make target directory for build.plugin.docs
mkdir -p target/docs

# remove any precompiled bits (also done in checkout_and_build_tarball.sh)
find . -regextype posix-egrep -regex '.*.jar|.*.zip|.*.class' -type f -print \
    | xargs rm -f

# create build classpath
export CLASSPATH=$(build-classpath checkstyle4-%{cs_ver} \
                          checkstyle4-optional-%{cs_ver})
for jar in \
%{_libdir}/eclipse/swt-gtk-%{eclipse_ver}.jar \
%{eclipse_base}/plugins/org.eclipse.core.commands_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.core.filebuffers_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.core.resources_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.core.runtime*.jar \
%{eclipse_base}/dropins/jdt/plugins/org.eclipse.jdt.core_%{eclipse_ver}.*.jar \
%{eclipse_base}/dropins/jdt/plugins/org.eclipse.jdt.ui_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.jface_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.jface.text_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.osgi_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.swt_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.team.core_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.team.cvs.core_*.jar \
%{eclipse_base}/plugins/org.eclipse.text_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.ui_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.ui.editors_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.ui.ide_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.ui.workbench_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.ui.workbench.texteditor_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.equinox.common_%{eclipse_ver}.*.jar \
%{eclipse_base}/plugins/org.eclipse.equinox.registry*.jar \
%{eclipse_base}/plugins/org.eclipse.core.jobs_*.jar
do
  CLASSPATH=$CLASSPATH:${jar}
done

pushd CheckstylePlugin/build

ant -Dbuild.sysclasspath=only \
    -Dcheckstyle.docs.dir=../target/docs \
    -Declipse.plugin.dir=%{eclipse_base}/plugins \
    -Dworkspace=.. \
    -Declipse.version=%{eclipse_ver} \
    -Dproject.name=CheckstylePlugin_4.0.1 \
    build.bindist

popd

%install
install -d -m 755 $RPM_BUILD_ROOT%{install_loc}
install -d -m 755 $RPM_BUILD_ROOT%{install_loc}/features/com.atlassw.tools.eclipse.checkstyle_%{version}
BUILD_DIR=`pwd`/CheckstylePlugin

# install feature
pushd $RPM_BUILD_ROOT%{install_loc}/features/com.atlassw.tools.eclipse.checkstyle_%{version}
   jar xvf ${BUILD_DIR}/dist/com.atlassw.tools.eclipse.checkstyle_%{version}-feature.jar
popd

# install plugin
pushd $RPM_BUILD_ROOT%{install_loc}
    jar xvf ${BUILD_DIR}/dist/com.atlassw.tools.eclipse.checkstyle_%{version}-bin.zip
    find . -type f -name '*src.zip' -print | xargs -t rm -f
    build-jar-repository \
    $RPM_BUILD_ROOT%{install_loc}/plugins/com.atlassw.tools.eclipse.checkstyle_%{version} \
    checkstyle4-%{cs_ver} \
    checkstyle4-optional-%{cs_ver} \
    commons-beanutils-core \
    commons-logging antlr
popd

%files
%doc CheckstylePlugin/license/LICENSE.*
%{install_loc}

%changelog
* Fri Mar 26 2010 Igor Vlasenko <viy@altlinux.ru> 4.0.1-alt2_14jpp6
- rebuild with checkstyle 4.4

* Wed Jan 27 2010 Igor Vlasenko <viy@altlinux.ru> 4.0.1-alt1_14jpp6
- new version

* Sun Jan 04 2009 Igor Vlasenko <viy@altlinux.ru> 4.0.1-alt1_11jpp6
- new version

* Thu Jul 31 2008 Igor Vlasenko <viy@altlinux.ru> 4.0.1-alt1_10jpp6
- rebuild with eclipse 3.3.2

* Fri Nov 30 2007 Igor Vlasenko <viy@altlinux.ru> 4.0.1-alt1_9jpp5.0
- converted from JPackage by jppimport script

